exports.floatformat = function(callback, input, val) {
    val = parseInt(val, 10);
    val = isNaN(val) ? -1 : val;

    var isPositive = val >= 0,
        asNumber = parseFloat(input),
        absValue = Math.abs(val),
        pow = Math.pow(10, absValue),
        pow_minus_one = Math.pow(10, Math.max(absValue-1, 0)),
        asString;

    asNumber = Math.round((pow * asNumber) / pow_minus_one);
    if(val !== 0)
      asNumber /= 10;

    asString = asNumber.toString();

    if(isPositive) {
        var split = asString.split('.'),
            decimal = split.length > 1 ? split[1] : '';

        while(decimal.length < val) {
            decimal += '0';
        }

        asString = decimal.length ? [split[0], decimal].join('.') : split[0];
    }

    callback(null, asString);
};
